import java.sql.*;
import java.util.*;
import java.util.regex.*;
import java.sql.*;
import java.text.DecimalFormat;

import bitel.billing.server.util.*;
import bitel.billing.server.contract.bean.*;
import bitel.billing.common.*;
import java.math.BigDecimal;

public void fillReport( con, filter, bitel.billing.server.reports.BGCSVReport.ReportResult result )
{
	int face = filter.getIntParam( "type", -1 );
	long group = filter.getLongParam( "contractGroups" );
	String status = filter.getStringParam( "status" );
	Calendar date = filter.getCalendarParam( "date" );
	Calendar month = filter.getCalendarParam( "month" );
	Calendar month_next = filter.getCalendarParam( "month" );
	String order = filter.getStringParam( "orderBy" );
	DecimalFormat dfSumm = new DecimalFormat( "0.00" );

	String query = "SELECT cb.summa1+cb.summa2-cb.summa3-cb.summa4 + " +
	" (SELECT IFNULL(SUM(cp.summa),0) FROM contract_payment cp WHERE cp.dt >=? AND cp.dt <=? AND cp.cid=cb.cid) AS summa" +
	" FROM contract_balance cb WHERE ( cb.yy<? OR (cb.yy=? AND cb.mm<=?) ) AND cb.cid=?" +
	" ORDER BY yy DESC, mm DESC LIMIT 1";
	
	PreparedStatement[] getSum = new PreparedStatement[5];
	
	int index = 1;
	month_next.add( Calendar.MONTH, 1 );

	for( int i = 0; i < 5; i++)
	{
		index = 1;

		getSum[i] = con.prepareStatement( query );
		
		getSum[i].setDate( index++, TimeUtils.convertCalendarToSqlDate( month_next ) );
		//System.out.println( TimeUtils.convertCalendarToSqlDate( month_next ) );
		//System.out.println( TimeUtils.convertCalendarToSqlDate( month ) );
	
		getSum[i].setDate( index++, TimeUtils.convertCalendarToSqlDate(date) );
		//System.out.println( TimeUtils.convertCalendarToSqlDate(date) );	
	
		getSum[i].setInt( index++, month.get( Calendar.YEAR ) );
		getSum[i].setInt( index++, month.get( Calendar.YEAR ) );
		//System.out.println( month.get( Calendar.YEAR ) );
		getSum[i].setInt( index++, month.get( Calendar.MONTH ) + 1 );
		//System.out.println( month.get( Calendar.MONTH ) + 1 );
		
		month.add( Calendar.MONTH, -1 );
		month_next.add( Calendar.MONTH, -1 );
	}
	
	query = "SELECT gr.title FROM contract_group gr WHERE (1<<gr.id) & ?>0";
	PreparedStatement getGroups = con.prepareStatement( query );
	
	String query = "SELECT c.id, c.gr, param_client.val, param_contract.val, param_account.val, param_phone.val, IFNULL(s.saldo,0)+IFNULL(p.summa,0) AS dept" +
			" FROM contract c" +
			//" LEFT JOIN contract_status cs ON c.id=cs.cid AND cs.date1<=CURDATE() AND (cs.date2 IS NULL OR cs.date2>=CURDATE())" +
			" LEFT JOIN contract_parameter_type_1 param_client ON param_client.cid=c.id AND param_client.pid=1" +
			" LEFT JOIN contract_parameter_type_1 param_contract ON param_contract.cid=c.id AND param_contract.pid=28" +
			" LEFT JOIN contract_parameter_type_1 param_account ON param_account.cid=c.id AND param_account.pid=3" +
			" LEFT JOIN contract_parameter_type_1 param_phone ON param_phone.cid=c.id AND param_phone.pid=26" +
			" LEFT JOIN (SELECT SUBSTR(MAX(CONCAT(RPAD(cb.yy*100+cb.mm,6,' '), cb.summa1+cb.summa2-cb.summa3-cb.summa4 )),7) AS saldo, cb.cid AS cid" +
  					" FROM contract_balance cb WHERE cb.yy<? OR (cb.yy=? AND cb.mm<=?) GROUP BY cid) s ON c.id=s.cid" +
  			" LEFT JOIN (SELECT SUM(cp.summa) AS summa, cp.cid AS cid FROM contract_payment cp" +
  					" WHERE cp.dt >=? AND cp.dt <=? GROUP BY cp.cid) p ON c.id=p.cid" +
			" WHERE ( IFNULL(s.saldo,0)+IFNULL(p.summa,0)<0 ) AND (c.scid=-1 OR c.scid=0 OR (c.sub_mode=1))";
	
	//System.out.println( query );

	if( status != "" )
	{
		query += " AND c.status IN (" + status + ")";
	}

	if( face >= 0 )
	{
		query += " AND c.fc = " + face;
	}
	if( group > 0 )
	{
		query += " AND (c.gr & ?) > 0 ";
	}
	
	if( order.equals( "one" ) )
	{
		query += " ORDER BY param_client.val ";
	}
	if( order.equals( "two" ) )
	{
		query += " ORDER BY dept ";
	}	
	if( order.equals( "three" ) )
	{
		query += " ORDER BY param_client.val DESC ";
	}	
	if( order.equals( "four" ) )
	{
		query += " ORDER BY dept DESC";
	}		
	//System.out.println( query );

	ps = con.prepareStatement( query );

	month = filter.getCalendarParam( "month" );
	month_next = filter.getCalendarParam( "month" );
	int index2 = 1;
	month_next.add( Calendar.MONTH, 1 );
	
	ps.setInt( index2++, month.get( Calendar.YEAR ) );
	ps.setInt( index2++, month.get( Calendar.YEAR ) );
	//System.out.println( month.get( Calendar.YEAR ) );
	ps.setInt( index2++, month.get( Calendar.MONTH ) + 1 );
	//System.out.println( month.get( Calendar.MONTH ) + 1 );
	
	ps.setDate( index2++, TimeUtils.convertCalendarToSqlDate( month_next ) );
	//System.out.println( TimeUtils.convertCalendarToSqlDate( month_next ) );
	//System.out.println( TimeUtils.convertCalendarToSqlDate( month ) );

	ps.setDate( index2++, TimeUtils.convertCalendarToSqlDate(date) );
	//System.out.println( TimeUtils.convertCalendarToSqlDate(date) );	
	
	if( group > 0 )
	{
		ps.setLong( index2++, group );
	}

	data = new ArrayList( 1000 );
	rs = ps.executeQuery();
	BigDecimal[] summa = new BigDecimal[5];
	BigDecimal[] summaItogo = new BigDecimal[5];
	for( i = 0; i < 5; i++ )
	{
		summaItogo[i] = BigDecimal.ZERO;
	}
	
	while( rs.next() )
	{
		cid = rs.getInt( "c.id" );
		long gr = rs.getLong( "c.gr" );
		
		groups = "";
		
		getGroups.setLong( 1, gr );
		groupRS = getGroups.executeQuery();
		while( groupRS .next() )
		{		
			if( groups != "")
			{
				groups = groupRS.getString(1) + ", " + groups; 
			}
			else
			{
				groups = groupRS.getString(1);
			}
		}		
		/*
		summa[0] = BigDecimal.ZERO;
		getSum[0].setInt( index, cid );
		sumRS = getSum[0].executeQuery();
		if( sumRS.next() )
		{
			summa[0] = sumRS.getBigDecimal( 1 );
		}
		
		if ( summa[0].floatValue() >= 0 )
		{
			continue;
		}
		*/
		for( i = 1; i < 5; i++ )
		{
			summa[i] = BigDecimal.ZERO;
			getSum[i].setInt( index, cid );
			sumRS = getSum[i].executeQuery();
			if( sumRS.next() )
			{
				summa[i] = sumRS.getBigDecimal( 1 );
			}
			sumRS.close();
			if( summa[i].compareTo( BigDecimal.ZERO ) > 0 )
			{
				summa[i] = BigDecimal.ZERO;
			}
			summaItogo[i] = summaItogo[i].add( summa[i] ); 
		}
		
		
		
		client = rs.getString( "param_client.val" );
		contract = rs.getString( "param_contract.val" );
		account = rs.getString( "param_account.val" );
		phone = rs.getString( "param_phone.val" );
		dept = rs.getBigDecimal( "dept" );
		summaItogo[0] = summaItogo[0].add( dept );
		
		map = new HashMap();
		map.put( "cid", String.valueOf( cid ) );
		map.put( "client", client );
		map.put( "contract", contract );
		map.put( "account", account );
		map.put( "phone", phone );
		map.put( "group", groups );
		map.put( "until30", dfSumm.format( dept ) );
		map.put( "between30and60", dfSumm.format( summa[1] ) );
		map.put( "between60and90", dfSumm.format( summa[2] ) );
		map.put( "between90and120", dfSumm.format( summa[3] ) );
		map.put( "more120",  dfSumm.format( summa[4] ) );
		data.add( map );
	}
	
	map = new HashMap();
	map.put( "client", ":" );
	map.put( "until30",  dfSumm.format( summaItogo[0] ) );
	map.put( "between30and60", dfSumm.format( summaItogo[1] ) );
	map.put( "between60and90",  dfSumm.format( summaItogo[2] ) );
	map.put( "between90and120", dfSumm.format( summaItogo[3] ) );
	map.put( "more120",  dfSumm.format( summaItogo[4] ) );
	data.add( map );
	
	result.setData( data );
}
